# hCore

### [Implement hCore to your project now](https://hcore.gitbook.io/wiki/#import)

## Little bit about hCore

HCore is a simplified and multi-functional tool for spigot developers. There are dozens of features you can use. HCore is also completely open source code. hCore supports all mc versions from 1.8.x to 1.19.x.

## Developers

### Owner:

* [@hakan-krgn](https://github.com/hakan-krgn) Discord: Hakan#2584

### Wiki && GitBook:

* [@rin-17](https://github.com/rin-17) - Wiki
* [@hogoshi](https://github.com/zhogoshi) - GitBook

#### [Click to go wiki page](https://github.com/hakan-krgn/hCore/wiki)

#### [Click to go gitbook page](https://hcore.gitbook.io/wiki)

### Contributors:

* [@furkanbalci0](https://github.com/furkanbalci0)
* [@osmanfurkan115](https://github.com/osmanfurkan115)
* [@imBuzz](https://github.com/imBuzz)
* [@Alpho320](https://github.com/Alpho320)
* [@rin-17](https://github.com/rin-17)
* [@bilektugrul](https://github.com/bilektugrul)
* [@hamza-cskn](https://github.com/hamza-cskn)
* [@hogoshi](https://github.com/zhogoshi)

## Features

- [`Annotation Commands`](https://hcore.gitbook.io/wiki/messaging/command-system) - Command system with annotations for registering commands
- [`NPCs`](https://hcore.gitbook.io/wiki/entities/npc) - NPC system for creating and managing client-side NPCs
- [`Databases`](https://hcore.gitbook.io/wiki/others/database-management) - Database implementation system with multi-database support
- [`Holograms`](https://hcore.gitbook.io/wiki/entities/holograms) - Hologram system for creating and managing holograms
- [`Scoreboards`](https://hcore.gitbook.io/wiki/messaging/scoreboards) - Scoreboard system for creating custom scoreboards
- [`Messaging`](https://hcore.gitbook.io/wiki/messaging/messagings) - Message system to send title, action-bar or boss-bar to player
- [`Packets`](https://hcore.gitbook.io/wiki/messaging/packets) - Packet system to listen to the packet and send it to players
- [`Event Subscriber`](https://hcore.gitbook.io/wiki/others/event-subscriber) - Event subscribe system to register listeners without any class
- [`Particles`](https://hcore.gitbook.io/wiki/entities/particles) - Particle system to play particle effects for players
- [`Renderers`](https://hcore.gitbook.io/wiki/entities/renderers) - Renderer system for rendering and sending the package to the closest players
- [`Schedulers`](https://github.com/hakan-krgn/hCore/wiki/Scheduler) - Scheduler system to easily create new scheduler
- [`Menus`](https://hcore.gitbook.io/wiki/others/inventories) - Menu system for creating custom inventories for players
- [`Anvils`](https://github.com/hakan-krgn/hCore/wiki/Anvil) - Anvil system for receiving input from the player
- [`Signs`](https://github.com/hakan-krgn/hCore/wiki/Sign) - Sign system for receiving input from the player
- [`WorldBorders`](https://hcore.gitbook.io/wiki/others/world-borders) - WorldBorder system to display WorldBorder
- [`ItemBuilder`](https://hcore.gitbook.io/wiki/others/itembuilder) - Using and creating custom items easily
- [`Configurations`](https://hcore.gitbook.io/wiki/configs/configs) - YAML and JSON config system for creating and manage configs easily
- [`Spam`](https://hcore.gitbook.io/wiki/messaging/spam-system) - Spam system to check if the provided ID is spamming
